#!/bin/bash
#Call this from cron @reboot. Check every 30 seconds that network is online.
#For the first minute, try more frequently, so as to light up as soon as we get online.
#Give fping multiple chances (-r 6), takes about 15 seconds) because network sometimes drops out briefly.
#Make this SILENT, else cron will try to email.

BLISO=`dirname $0`/bliso.sh

function find_gateway(){				#default gateway (empty string if no network)
	read _ _ gateway _ < <(ip route list 0/0)
}

function do_pwm(){					#Set pwm to value (1 or 5)
	$BLISO pwm$1 >/dev/null 2>&1;
}

do_pwm 1;do_pwm 5;do_pwm 1;do_pwm 5;do_pwm 1;do_pwm 5;  #Blink on start
do_pwm 1; 						#Set dim till we find gateway.

count=0
while : ; do
	while : ; do					#find the gateway.
		[ -z "$gateway" ] && find_gateway
		[ -n "$gateway" ] && break;
		do_pwm 1
		sleep 3
	done
	if fping -q -r 6 $gateway; then			#success: pwm bright
		do_pwm 5
	else
		gateway=''				#fail: pwm dim
		do_pwm 1
	fi

	if [ $count -lt 20 ]; then			#Don't waste bandwidth.
		sleep 5
		count=$((count+1))
	else
		sleep 20
	fi
done
