<?
#This (self-contained) page on the Pi interfaces between the web (probably on a smartphone) and the BLISO device (blinking lights and sounder).
#This script copyright by Richard Neill (www.richardneill.org), 2013.  Free Software, licensed under the GNU GPL, version 3+.
#See richardneill.org/source for the project.

#Find the beep/flash script.
$this_script = $_SERVER['SCRIPT_FILENAME'];
$bliso = dirname(realpath($this_script))."/bliso.sh";
if (!is_executable($bliso)){
	echo "Error: cannot execute: $bliso";
}

#As the icons are tiny, embed them in a data:URI to reduce request latency.
function data_uri($icon){ 
	$this_script = $_SERVER['SCRIPT_FILENAME'];
	$file = dirname(realpath($this_script))."/$icon";
	$base64 = base64_encode (file_get_contents($file));
	return ("data:image/png;base64,$base64");
}

#What time is it? What is the appropriate meal? Set colours (gradient is defined by $c[1],$c[2],$c[3], typically #f00, #c0, #800).
$red = array (1=>'#f00', 2=>'#c00', 3=>'#800');  $blue = array (1=>'#00f', 2=>'#00c', 3=>'#008');  
$c = $blue;
date_default_timezone_set('Europe/London');
$hour = date("H");
#$hour = 12; //test
if ($hour < 1){
	$meal="coffee"; $mealtime="It's time for a nightcap:";
}elseif ($hour < 5){
        $meal="midnight feast"; $mealtime="It's time for a snack:";
}elseif($hour < 10){
        $meal="breakfast"; $mealtime="It's breakfast time:";
}elseif($hour < 12){
        $meal="coffee"; $mealtime="It's time for coffee:";  $c = $red;
}elseif($hour < 15){
        $meal="lunch"; $mealtime="It's lunch time:";	$c = $red;
}elseif($hour < 18){
        $meal="tea"; $mealtime="It's tea time:"; $c = $red;
}elseif($hour < 22){
        $meal="supper"; $mealtime="It's supper time:";
}else{
        $meal="chocolate"; $mealtime="Chocolate and ice-cream:";
}

#Various levels of notification. 0 is off, becoming more urgent up to 5.
#$bliso_arg is the argument to bliso.sh. $btntexts, $btnicons, $titles, $descriptions are for the GUI. $times are estimates of how long bliso.sh will take to run (for the message to automatically be dismissed [see below, not used]). $css is custom CSS for image-positioning.
$bliso_arg  =   array (0=>"offquiet", 1=>"5min",                                     2=>"alert",                     3=>"remind",                         4=>"nag",                       5=>"NOW");
$btntexts   =   array (0=>"off",      1=>"In 5 minutes",                             2=>" Announce ",                3=>" Reminder &nbsp;&nbsp;",              4=>" Come on &nbsp; ",          5=>"It&#039;s Burning! ");  
$btnicons   =   array (0=>"",         1=>"78-stopwatch.png",                         2=>"48-fork-and-knife.png",     3=>"194-note-2.png",                 4=>"63-runner.png",             5=>"82-dog-paw.png");  
$css	    =   array (0=>"",         1=>"",                                         2=>"margin-left:-6px",          3=>"",                               4=>"margin-left:-6px",          5=>"");  
$titles     =   array (0=>"off",      1=>"Lights will count down",                   2=>"Gently announce",           3=>"Subtle reminder",                4=>"A longer beep",             5=>"Lots of beeps"); 
$descriptions = array (0=>"off",      1=>ucfirst($meal)." will be in 5 minutes",     2=>"Announcing $meal...",       3=>"Reminding about $meal...",       4=>"Insisting upon $meal!",     5=> ucfirst($meal)." will soon be in the dog!!");  
$times      =   array (0=>0,          1=>300,                                        2=>5,                           3=>2,                                4=>6,                           5=>20);    

#Beep/Flash (in background), so that the web interface responds quickly. (ending is simulated with JS). Invoked by Ajax query.
if (isset($_GET['ajax'])){	//Respond to Ajax request with XML document, then exit.
	$action=intval($_GET['ajax']);
	if (($action >= 0 and $action < 6)){
		$cmd = "$bliso $bliso_arg[$action] >/dev/null 2>&1 &";  #don't wait for completion.
		shell_exec ($cmd);
		#echo $cmd;
		$status = $descriptions[$action];	//return to client: text string, and estimate in ms.
		$data   = 4000;				//$times[$action] * 1000;  #Actually, the GUI is better if this is constant.
	}else{
		$status = "ERRROR";
		$data   = 0;
	}
        header("Content-Type: application/xml");        //Create a simple XML document, with the correct Mime-type. 
        header("Pragma: no-cache");                     //Don't cache! Else, the client sees the change OK, but the server doesn't!
        header("Cache-Control: max-age=0, s-maxage=0, no-cache, must-revalidate");
        $status=htmlspecialchars($status, ENT_NOQUOTES); //Convert <,>,&  to entities.   (xmldoc undoes this later)
        $data=htmlspecialchars($data, ENT_NOQUOTES);
        echo '<?xml version="1.0" ?>'; 
        echo '<root>';
        echo "<status>$status</status>";
        echo "<data>$data</data>";
        echo '</root>';
        exit();  					//Now exit.
}

#A single simple HTML page, with embedded CSS and JS. The meta-viewport link makes it work well on a smartphone. The body.font-size controls overall scaling.
#The second meta link is recommended for iOS, but has no effect on Firefox or Android.
?>
<!DOCTYPE html>
<HTML>
<HEAD><meta charset="utf-8">
<META name="viewport" content="user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0, width=device-width">
<META name="apple-mobile-web-app-capable" content="yes" />
<LINK rel='icon' href='images/48-fork-and-knife_2x.png' type='image/x-icon'>
<TITLE>Dinner is Served</TITLE>

<STYLE>
* {  margin: 0; }
html, body { height: 100%; }
body { padding: 0;  margin: 0; font-size: 10pt !important; font-family: Tahoma, Helvetica, Times, Sans; background-color: #fff; color: #000; }
#outer { min-height: 100%; height: auto !important; height: 100%; margin: 0 auto -3em }  /* -3em here, must be same as #push/#footer height and #footer line-height */
#menu { height: 3em; padding-left: 1em; padding-right: 1em; line-height: 3em; text-align: center; vertical-align:middle; clear: both; color:#fff; font-weight: bold}
#push, #footer { height: 3em}
#footer{ padding-left: 1em; padding-right: 1em; line-height: 3em; text-align:center; vertical-align:middle; clear:both; color:#fff; font-weight: bold}
#content { }
#menu, #footer, input[type='submit'], input[type='button'], a.button {
  background: <?=$c[2];?>; background: -moz-linear-gradient(top, <?=$c[1];?> 1%, <?=$c[2];?> 31%, <?=$c[3];?> 96%); background: -webkit-linear-gradient(top, <?=$c[1];?> 1%,<?=$c[2];?> 31%,<?=$c[3];?> 96%);
  background: -ms-linear-gradient(top, <?=$c[1];?> 1%,<?=$c[2];?> 31%,<?=$c[3];?> 96%); background: linear-gradient(top, <?=$c[1];?> 1%,<?=$c[2];?> 31%,<?=$c[3];?> 96%); }
h1 { text-align: center; margin-top: 0.5em; margin-bottom: 0.3em}
div.menu, div.action {  width: 100%;}
div.actionitem { display: inline-block; text-align: center; }
a.button {  display: inline-block; white-space: nowrap; margin: 1em; padding: 1em 2em; min-width: 15em; border: 1px solid <?=$c[2];?>; border-radius: 0.5em; text-decoration: none;  clear: both; vertical-align: middle; font-weight:bold;  color: #fff !important; user-select: none; -moz-user-select: -moz-none; -khtml-user-select: none; -webkit-user-select: none; }
a.button:active {color: #bbb; border: 1px solid black}
a.button img {  vertical-align: middle; }
img + span.buttontext{  margin-left: 3em;}
.equi1 { float: left; width: 100%; }
</STYLE>

<SCRIPT>
//Make the AJAX request.
function makeRequest(url){
	var httpRequest;
	if (window.XMLHttpRequest) { //Mozilla, Safari
		httpRequest = new XMLHttpRequest();
		if (httpRequest.overrideMimeType) {
			httpRequest.overrideMimeType('text/xml');
		}
	}else if (window.ActiveXObject){ //IE
		try{
			httpRequest = new ActiveXObject("Msxml2.XMLHTTP");
		}catch (e){
			try{
			httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
			}catch (e) {
				alert ("Ajax not supported");
			}
		}
	}
	if (!httpRequest) {
		alert('Cannot create an XMLHTTP instance');
		return false;
	}
	httpRequest.onreadystatechange = function() { receiveResponse(httpRequest); };
	httpRequest.open('GET', url, true);
	httpRequest.send(null);
}
//Receive the response.
function receiveResponse(httpRequest) {
	try {
		if (httpRequest.readyState == 4){
			if (httpRequest.status == 200) {
				var xmldoc = httpRequest.responseXML;      //Parse XML-doc.
				var statustag = xmldoc.getElementsByTagName('status').item(0).firstChild;
				if (statustag !== null){
					var status = statustag.data;
				}
				if (status === null){
					status='';
				}
				var datatag = xmldoc.getElementsByTagName('data').item(0).firstChild;
				if (datatag !== null){
					var data = datatag.data;
				}
				if (data === null){
					data='';
				}
				dealWithResponse(status,data);             //response function.
			}else{
				alert('Ajax response error');
				return false;
			}
		}
	}catch(e) {
		return false;
	}
}
//Now deal with the response.
function dealWithResponse(status,data){  //status is text, data is time in ms.
	//alert('Status is: ' + status + ' and the data is: ' + data);
	document.getElementById('menu').innerHTML = status;
	window.setTimeout('document.getElementById("menu").innerHTML="Time for Something Tasty"', (data*1) );
}
</SCRIPT>
</HEAD>

<BODY>
<div id=outer>
<div id=menu onclick="window.location='index.php';">Time for Something Tasty<div style='clear:both'></div></div>
<div id=content>
<h1><?=$mealtime;?></h1>
<noscript><p>Please enable JavaScript, or this won't work.</p></noscript>

<form action="index.php" METHOD=POST>

<div class=action>
<div class='actionitem equi1'>
<? for ($i=1; $i<=5; $i++){
	echo "<a class='button' onclick=\"makeRequest('index.php?ajax=$i');return false;\" title='$titles[$i]' unselectable='on'><img src='".data_uri("images/$btnicons[$i]")."' style='$css[$i]' alt=''><span class=buttontext>$btntexts[$i]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span></a><br>";
}?>
</div><div style='clear:both'></div></div>

</form>

</div>
<div id=push></div></div>
<div id=footer onclick="window.location='index.php';">Created by RJN for JMN, 21st July 2013</div>
</BODY>
</HTML>
